-- Usando informacion de:
-- 
LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE work.PK_GEN_PULSO.all;

ENTITY gen_pulso_tb IS
END gen_pulso_tb;

ARCHITECTURE behav of gen_pulso_tb IS

signal s_clk : std_logic := '0';
signal s_reset : std_logic := '0';
signal s_input : std_logic := '0';
signal s_edge_detected : std_logic;

constant T : time := 20 ns;
constant td : time := 5 ns;
constant t_reset : time := 2*T + td;

-- declare record type
    type test_vector is record
        input : std_logic;
        ed    : std_logic;
    end record;

type test_vector_array is array (natural range <>) of test_vector;
constant test_vectors : test_vector_array := (
-- input , expected output
  ( '0' , '0' ), -- entreda en 0
  ( '1' , '1' ), -- ** cambia  entrada a 1 
  ( '1' , '1' ), -- se debe de generar pulso
  ( '1' , '0' ), -- debe bajar la salida 
  ( '0' , '0' ), -- ** cambia entrada a 0
  ( '0' , '0' ), -- no se deben de generar pulsos
  ( '0' , '0' ), --  
  ( '1' , '1' )
  );

begin

   -- clock
   s_clk <= not s_clk after T/2;
   -- reset
   s_reset <= '1', '0' after t_reset;
   
   
   DUT : GEN_PULSO port map (
      clk            => s_clk,
      reset          => s_reset,
      input          => s_input,
      edge_detected  => s_edge_detected
   );


   
   stimulus: process
   begin
     wait for t_reset;
     
     for i in test_vectors'range loop
       s_input <= test_vectors(i).input;  -- signal a = i^th-row-value of test_vector's a

       assert ( s_edge_detected = test_vectors(i).ed )

            -- image is used for string-representation of integer etc.
            report  "test_vector " & integer'image(i) & " failed " & 
                    " for input  = " & std_logic'image(s_input) 
                    severity error;
       wait until s_clk = '1';
       wait for td;
     end loop;
        
        
   end process stimulus;

end behav;
